"use strict";

const mongoose = require("mongoose");

const findComponentByGlobalId = (globalId) => {
  return Object.values(strapi.components).find(
    (compo) => compo.globalId === globalId
  );
};

const getRelationKeyType = (type) => {
  // String, Number, ObjectId
  switch (type) {
    case "String":
      return mongoose.Schema.Types.String;
    case "Number":
      return mongoose.Schema.Types.Number;
    case "ObjectId":
      return mongoose.Schema.Types.ObjectId;
    default:
      return mongoose.Schema.Types.ObjectId;
  }
};

const getRelationKeyConstructor = (type) => {
  // String, Number, ObjectId
  switch (type) {
    case "String":
      return mongoose.Types.String;
    case "Number":
      return mongoose.Types.Number;
    case "ObjectId":
      return mongoose.Types.ObjectId;
    default:
      return mongoose.Types.ObjectId;
  }
};

module.exports = {
  findComponentByGlobalId,
  getRelationKeyType,
  getRelationKeyConstructor,
};
